﻿@using Services;
@using WebCalc.Constants;
@inject ConvertService convertService

<div>
    <EditForm Model="@DummyModel">
        <div class="form-group">
            <h6>(Fahrenheit - 32) * (5 / 9) = Celsius = Kelvin - 273.15</h6>
        </div>
        <div class="form-group">
            <table class="table table-sm">
                <tbody>
                    <tr>
                        <td>Fahrenheit</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@TemperatureType.Fahrenheit" checked="@((TempType == TemperatureType.Fahrenheit))" @onchange="__e => TempType = TemperatureType.Fahrenheit" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@FahrenheitValue" @oninput="((ChangeEventArgs __e) => FahrenheitValue = ToDouble(__e?.Value))" disabled="@(!(TempType == TemperatureType.Fahrenheit))" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Celsius</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@TemperatureType.Celsius" checked="@((TempType == TemperatureType.Celsius))" @onchange="__e => TempType = TemperatureType.Celsius" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@CelsiusValue" @oninput="((ChangeEventArgs __e) => CelsiusValue = ToDouble(__e?.Value))" disabled="@(!(TempType == TemperatureType.Celsius))" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                    <tr>
                        <td>Kelvin</td>
                        <td>
                            <div class="input-group">
                                <div class="input-group-prepend">
                                    <div class="input-group-text">
                                        <input type="radio" name="optTemp" value="@TemperatureType.Kelvin" checked="@((TempType == TemperatureType.Kelvin))" @onchange="__e => TempType = TemperatureType.Kelvin" />
                                    </div>
                                </div>
                                <input class="form-control form-control-sm mr-sm-2" value="@KelvinValue" @oninput="((ChangeEventArgs __e) => KelvinValue = ToDouble(__e?.Value))" disabled="@(!(TempType == TemperatureType.Kelvin))" maxlength="6" />
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </EditForm>
</div>

@code {

    private string DummyModel { get; set; } = string.Empty;

    private double FahrenheitValue { get; set; } = 0;
    private double CelsiusValue { get; set; } = 0;
    private double KelvinValue { get; set; } = 0;

    private TemperatureType TempType { get; set; } = TemperatureType.Celsius;

    private double ToDouble(object value) => convertService.ToDouble(value);

    protected override bool ShouldRender()
    {
        RefreshValues();
        return base.ShouldRender();
    }

    private void RefreshValues()
    {
        switch (TempType)
        {
            case TemperatureType.Fahrenheit:
                CelsiusValue = Math.Round(convertService.ConvertTemperature(TemperatureType.Fahrenheit, TemperatureType.Celsius, FahrenheitValue), 2);
                KelvinValue = Math.Round(convertService.ConvertTemperature(TemperatureType.Fahrenheit, TemperatureType.Kelvin, FahrenheitValue), 2);
                break;
            case TemperatureType.Celsius:
                FahrenheitValue = Math.Round(convertService.ConvertTemperature(TemperatureType.Celsius, TemperatureType.Fahrenheit, CelsiusValue), 2);
                KelvinValue = Math.Round(convertService.ConvertTemperature(TemperatureType.Celsius, TemperatureType.Kelvin, CelsiusValue), 2);
                break;
            case TemperatureType.Kelvin:
                FahrenheitValue = Math.Round(convertService.ConvertTemperature(TemperatureType.Kelvin, TemperatureType.Fahrenheit, KelvinValue), 2);
                CelsiusValue = Math.Round(convertService.ConvertTemperature(TemperatureType.Kelvin, TemperatureType.Celsius, KelvinValue), 2);
                break;
            default:
                throw new NotImplementedException();
        }
    }
}
